require 'cucumber-rest-bdd'
require 'alinta-testing/overrides/get_url'

class Hash
  def deep_include?(other)
    diff = other.easy_diff(self)
    diff[0].delete_if { |_k, v| v.empty? if v.is_a?(::Hash) }
    # this line is new and supports regular expressions
    diff[0].delete_if { |_k, v| v.match(diff[1][_k]) if v.is_a?(::Regexp) }
    diff[0].empty?
  end
end

def parse_attributes(hashes)
  hashes.each_with_object({}) do |row, hash|
    name = row['attribute']
    value = row['value']
    type = row['type']
    # this condition is new and allows the value to be resolved from ruby code
    if type == 'expression'
      value = eval(value) 
    else
      value = resolve_functions(value)
      value = resolve(value)
      value.gsub!(/\\n/, "\n")
      value = string_to_type(value, type)
    end
    names = split_fields(name)
    new_hash = names.reverse.inject(value) { |a, n| add_to_hash(a, n) }
    hash.deep_merge!(new_hash) { |_, old, new| new.is_a?(Array) ? merge_arrays(old, new) : new }
  end
end

module RestClient

  # A global setting to verify ssl certs for all requests. This can be overridden on a
  # per-request basis by passing `:verify_ssl` to RestClient::Request.
  def self.verify_ssl
    @verify_ssl ||= nil
  end

  def self.verify_ssl=(value)
    @verify_ssl = value
    @verify_ssl_set = true
  end

# Return whether RestClient.verify_ssl was set explicitly. We use this to
# differentiate between no value being set and a value explicitly set to nil.
#
# @return [Boolean]
#
def self.verify_ssl_set?
  @verify_ssl_set ||= false
end    
  
class Request

    def verify_ssl
      if RestClient.verify_ssl_set?
        if RestClient.verify_ssl
          OpenSSL::SSL::VERIFY_PEER
        else
          OpenSSL::SSL::VERIFY_NONE
        end
      else
        @ssl_opts.fetch(:verify_ssl)
      end
    end

end

end
