
def get_url(path)
    raise %(Please set an 'endpoint' environment variable provided with the url of the api) unless ENV.key?('endpoint')

    get_url_internal(path, ENV['endpoint'], @urlbasepath, ENV['api_version'])
end

def get_url_internal(path, endpoint, urlbasepath, apiversion)
    # remove leading and trailing slashes
    endpoint = endpoint.gsub(/^(.*?)\/?$/, '\1')
    path = path.gsub(/^\/?(.*?)\/?$/, '\1') unless path.to_s.empty?
    urlbasepath = urlbasepath.gsub(/^\/?(.*?)\/?$/, '\1') unless urlbasepath.to_s.empty?
    apiversion = apiversion.gsub(/^\/?(.*?)\/?$/, '\1') unless apiversion.to_s.empty?

    path = "#{urlbasepath}/#{path}" unless urlbasepath.to_s.empty?

    splitpath = path.split('/')
    basepath =  splitpath.first()
    path = splitpath.drop(1).join('/')
    
    # base end point for all calls
    url = endpoint
  
    # common sub-path for this feature
    url = "#{url}/#{basepath}" unless basepath.to_s.empty?
  
    # versioned route for UAT environments
    url = "#{url}/#{apiversion}" unless apiversion.to_s.empty?
  
    # final path for this request
    url = "#{url}/#{path}" unless path.to_s.empty?

    url
  end